-- Dada --

Timon = {};
Timon.modDirectory = g_currentModDirectory;

function Timon.prerequisitesPresent(specializations)
      return true;
end;
function Timon.initSpecialization()
	local schema = Vehicle.xmlSchema
    schema:setXMLSpecializationType("Timon")
	schema:register(XMLValueType.NODE_INDEX, "vehicle.Timon#trigger", "trigger node")
	schema:register(XMLValueType.NODE_INDEX, "vehicle.Timon#timon1", "timon1 node")
	schema:register(XMLValueType.NODE_INDEX, "vehicle.Timon#timon2", "timon2 node")
	schema:register(XMLValueType.NODE_INDEX, "vehicle.Timon.Point(?)#node", "node")
	schema:register(XMLValueType.NODE_INDEX, "vehicle.Timon.Point(?)#vis", "visual")
	schema:register(XMLValueType.NODE_INDEX, "vehicle.Timon.Point(?)#selection", "selection visual")
	schema:register(XMLValueType.FLOAT, "vehicle.Timon.Point(?)#rayon", "rayon")
	schema:register(XMLValueType.STRING, "vehicle.Timon.Point(?)#fonction", "fonction name")		
	schema:register(XMLValueType.STRING, "vehicle.Timon.Point(?)#animReset", "fonction name to reset")	
	schema:register(XMLValueType.FLOAT, "vehicle.Timon.Point(?)#initState", "fonction name")
	schema:register(XMLValueType.FLOAT, "vehicle.Timon.Point(?)#Fmax", "maximum state")
	schema:register(XMLValueType.BOOL, "vehicle.Timon.Point(?)#Update", "Update Require")	
	schema:register(XMLValueType.BOOL, "vehicle.Timon.Point(?)#onOff", "On / Off state")	
	schema:register(XMLValueType.BOOL, "vehicle.Timon.Point(?)#disableOnStart", "disable fonction on start")
end
function Timon.registerOverwrittenFunctions(vehicleType)
end
function Timon.registerFunctions(vehicleType)	
	SpecializationUtil.registerFunction(vehicleType, "ProcessAction", Timon.ProcessAction)		
end
function Timon.registerEvents(vehicleType)
end
function Timon:registerActionEventsPlayer()
end
function Timon:registerActionEventsMenu()
end


function Timon:onRegisterActionEvents(isSelected, isOnActiveVehicle)
	if isOnActiveVehicle then
	end
end

function Timon.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", Timon)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", Timon)
    SpecializationUtil.registerEventListener(vehicleType, "onReadStream", Timon)
    SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", Timon)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", Timon)
	SpecializationUtil.registerEventListener(vehicleType, "onDraw", Timon)
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", Timon)
end

function Timon:onLoad(vehicle)
	self.timon1 = self.xmlFile:getValue("vehicle.Timon#timon1", nil, self.components, self.i3dMappings)
	setRotation(self.timon1, -1.74, 0, 0)
	self.timon2 = self.xmlFile:getValue("vehicle.Timon#timon2", nil, self.components, self.i3dMappings)
	setRotation(self.timon2, 1.57, 0, 0)
	self.timonTiggerCallback = Timon.timonTiggerCallback;
	self.triggerP = self.xmlFile:getValue("vehicle.Timon#trigger", nil, self.components, self.i3dMappings)
	self.triggerId = addTrigger(self.triggerP, "timonTiggerCallback", self)
	self.value = 0
	self.plus = false
	self.moins = false
	self.playerInTrigger = false
	self.Points = {}
	n = 0 
	while true do 
		local key = string.format("vehicle.Timon.Point(%d)", n)
		if not self.xmlFile:hasProperty(key) then
            break
        end
		node = self.xmlFile:getValue(key .. "#node", nil, self.components, self.i3dMappings)
		vis = self.xmlFile:getValue(key .. "#vis", nil, self.components, self.i3dMappings)
		selection = self.xmlFile:getValue(key .. "#selection", nil, self.components, self.i3dMappings)
		setVisibility(selection, false)
		raduis = self.xmlFile:getValue(key .. "#rayon", 0.25)
		name = self.xmlFile:getValue(key .. "#fonction", "")
		maximum = self.xmlFile:getValue(key .. "#Fmax", 1)
		updateR = self.xmlFile:getValue(key .. "#Update", false)
		initialState = self.xmlFile:getValue(key .. "#initState", 0)
		onOff = self.xmlFile:getValue(key .. "#onOff", false)
		enable = self.xmlFile:getValue(key .. "#disableOnStart", false)
		animReset = self.xmlFile:getValue(key .. "#animReset", "")
		local fonction = {}
		fonction.name = name
		fonction.maximum = maximum
		fonction.state = initialState
		self:setAnimationTime(name, 0, true, true)
		self:setAnimationTime(name, initialState, true, true)
		fonction.updateR = updateR
		fonction.onOff = onOff		
		fonction.animReset = animReset
		fonction.enable = not enable
		fonction.initialState = initialState
		local point = {node, vis, selection, raduis}
		point.fonction = fonction
		table.insert(self.Points, point)
		n = n + 1
	end	
end;

function Timon:onDelete() 
	if self.triggerP ~= nil then
		removeTrigger(self.triggerP)
	end
end;

function Timon:onReadStream(streamId, connection)
end;

function Timon:onWriteStream(streamId, connection)
end;

function Timon:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Timon:keyEvent(unicode, sym, modifier, isDown)    
end;

function Timon:timonTiggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
    if onEnter then
		self.playerInTrigger = true
		
		self:raiseActive()
		self.actionEventsT = {}; 
		self:clearActionEventsTable(self.actionEventsT);
		for _,actionName in pairs({"plus", "moins"}) do
			local _, eventName = self:addActionEvent(self.actionEventsT, InputAction[actionName], self, Timon.actionCallback, false, true, true, true, nil);
		end
	end
	if onLeave then
		self.playerInTrigger = false
		for _,actionName in pairs({"plus", "moins"}) do
			self:removeActionEvent(self.actionEventsT, InputAction[actionName]);
		end

		for _, point in pairs(self.Points)do
			if getVisibility(point[3]) then
				setVisibility(point[3], false)
				setVisibility(point[2], true)
			end
		end
	end
end

function Timon:onUpdate(dt, vehicle)
	for _, fonction in pairs(self.Points) do
		local fonction = fonction.fonction
		if fonction.updateR then
			self:ProcessAction(fonction.name, fonction.state, fonction)
		end
	end
	if self.playerInTrigger then
		for _, point in pairs(self.Points)do
			for _, player in pairs(g_currentMission.players)do
				local r = point[4]
				local px, py, pz = getWorldTranslation(point[1])
				local x, y, z = project(px, py, pz);
				
				
				local cX, cY, cZ = getWorldTranslation(player.getCurrentCameraNode());
				local dist = MathUtil.vector3Length(px-cX, py-cY, pz-cZ); 
				if x > 0 and y > 0 and z > 0 and point.fonction.enable then
					local posX, posY, posZ = 0.5, 0.5, 0.5;
					if math.abs((x-posX)) < r and math.abs(y-posY) < r then

						local fonction = point.fonction
						local initialFstate = fonction.state
						if self.plus then
							local state = fonction.state
							if state < fonction.maximum then
								fonction.state = state + 0.01
							end
							
						end
						if self.moins then
							local state = fonction.state
							if state > 0 then
								fonction.state = state - 0.01
							end
							
						end
						--if initialFstate ~= fonction.state then
							self:ProcessAction(fonction.name, fonction.state, fonction)
						--end
						setVisibility(point[2], false)
						setVisibility(point[3], true)
						self.plus = false
						self.moins = false
					elseif getVisibility(point[3]) then
						setVisibility(point[3], false)
						setVisibility(point[2], true)
					end
				end
			end
		end
	end
	
end;


function Timon:onUpdateTick() 
end;

function Timon:onDeactivate()
end;

function Timon:onDraw()  
end;


function Timon:actionCallback(a, actionName, inputValue, callbackState, isAnalog, isMouse)
		if a == 'plus' then
				self.plus = true
		elseif a == 'moins' then
				self.moins = true
		end
		

end


function Timon:ProcessAction(action, state, fonction)
	local spec_motorized = self.spec_motorized
	if fonction.enable then
		if fonction.onOff then
			if self.plus then
				self:playAnimation(action, 1, nil, true)
				if fonction.animReset ~= "" then
					for _, point in pairs(self.Points)do
						if point.fonction.name == fonction.animReset then
							point.fonction.enable = true
						end
					end
				end
			end
			if self.moins then
				if fonction.animReset ~= "" then
					self:playAnimation(fonction.animReset, -1, nil, true)
					for _, point in pairs(self.Points)do
						if point.fonction.name == fonction.animReset then
							point.fonction.enable = false
							point.fonction.state = point.fonction.initialState
						end
					end
				end
				self:playAnimation(action, -1, nil, true)
			end
		else
			self:setAnimationTime(action, state, true, true)
		end
	end
end
